//  ,   ,
//       .
//   .
#include <iostream>
#include <string>
using namespace std;

//------------------------------------------------------------------------
//  .   
class tape
{
public:
  //     .
  virtual void First() = 0; 
  //     .
  virtual void Next() = 0; 
  //   .
  //  \0,   .
  virtual char Read() = 0; 
};

//     
class string_tape: public tape
{
public:
  void First() {  _i = 0; } 
  void Next()  { ++_i; }
  char Read() { return _s[_i]; }
  // 
  string_tape(string s): _s(s), _i(0) { }
private:
  string _s; //    
  int _i;    //   
};

//------------------------------------------------------------------------
//   
int FirstCounter(tape &t)
{
  int counter = 0;
  t.First();
  char c = t.Read();
  if(c=='\0') return 0;
  do
  {
    counter++;
    t.Next();
  }
  while(c == t.Read());
  return counter;
}

//------------------------------------------------------------------------
//        
int NextCounter(tape &t)
{
  int counter = 0;
  char c = t.Read();
  if(c=='\0') return 0;
  do
  {
    counter++;
    t.Next();
  }
  while(c == t.Read());
  return counter;
}

//------------------------------------------------------------------------
//    ,
// ,   
bool common_parser(tape &t)
{
  //    
  int counter = FirstCounter(t);
  if(counter == 0) return false; //  
  //    
  while(t.Read() != '\0')
  {
    int tail_counter = NextCounter(t);
    //     
    if(counter != tail_counter) return false;
  }
  return true;
}

//------------------------------------------------------------------------
//      
//  
//    ,   
//  
bool limited_parser(tape &t, string s="")
{
  //     
  if(s=="") common_parser(t); //  
  else { //   
    //     
    t.First();
    if(s[0] != t.Read()) return false; //   

    //      
    //    
    int counter = FirstCounter(t);
    if(counter == 0) return false; //  

    //    
    int i = 1; //    
    while(t.Read() != '\0') //  
    {
      if(s[i] != t.Read()) return false; //   
      int tail_counter = NextCounter(t);
      //     
      if(counter != tail_counter) return false;
      i++; //   
    }
    //     
    if(i != s.length()) return false;
  }
  return true;
}

//------------------------------------------------------------------------
//   : 101,
bool parser_101(tape &t)
{
//_0:
  int c;     //    
	int n;		 //       
  t.First(); //    
	//    
	if(t.Read()=='1') {c=1; t.Next(); goto _1;}
	return false;
_1: //        
	if(t.Read()=='1') {c++; t.Next(); goto _1;}
	if(t.Read()=='0') {n=1; t.Next(); goto _2;}
	return false;
_2: //          
	if(t.Read()=='0') {
		n++; 
		if(n>c) return false;
		t.Next(); goto _2;
	}
	if(t.Read()=='1') {
		if(n<c) return false;
		n=1; 
		t.Next(); goto _3;
	}
	return false;
_3: //     
	if(t.Read()=='1') {
		n++; 
		if(n>c) return false;
		t.Next(); goto _3;
	}
	if(n<c) return false;
	goto _end; //       
_end:
	//    
	if(t.Read()!='\0') return false;
	return true;
}

//------------------------------------------------------------------------
//  
void main()
{
  tape *t;

  cout << "common_parser testing" << endl;

  t = new string_tape("aaafffsssqqqwww");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("aaaabbb");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("1122334455");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("110011001100");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("110011100");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("11111111111111");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("");
  if(common_parser(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  cout << "limited_parser testing" << endl;

  t = new string_tape("111000111000111");
  if(limited_parser(*t, "10101")) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  cout << "parser_101 testing" << endl;

  t = new string_tape("101");
  if(parser_101(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("111100001111");
  if(parser_101(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("111000111aaa");
  if(parser_101(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;

  t = new string_tape("11100011000111");
  if(parser_101(*t)) 
		cout << "Chain is correct!" << endl;
  else 
		cout << "Chain is bad!" << endl;
  delete t;
}